// LSystem v2.0
//
//
// Description:
//
// Advanced Lindermayer (LSystem) Fractal Generator
//
//
// Author:
//
// Bertrand Lempereur
// email: blempereur@yahoo.com
//	    b.lempereur@noos.fr
// url http://blempereur.einden.com/
//
// Date:
//
// 20/04/04

extern "nrfx.dll" image NGLRender(
int		width,
int		height,
int		bytes,
const char	*expr
);

image LSystem2(
int width = 400,
int height =400,
int bytes = 1,

const char * axiom = "X",
const char * F = ">>;;FF::<<",
const char * X = "F[+X]F[-X]+X",
const char * Y = "",
const char * A = "",
const char * B = "",
const char * C = "",
const char * D = "",
const char * E = "",
float angle = 25,
int iteration = 5,
float zoom = 5.5,
float startAngle = 90,
float xCenter = 200,
float yCenter = 25,
string drawType = "Line",
float Red = 0.8, float Green = 0.7, float Blue = 0.4,
float stepColor = 0.0464,
float ptBaseSize = 0.5,
float ptStepSize = 0.444,
//string colorType = "Fill",
const char * factorDraw = "F",
const char * factorNoDraw = "G",
const char * reverseAngle = "R",
const char * increaseColor = ":",
const char * decreaseColor = ";",
const char * increaseAngle = "+",
const char * decreaseAngle = "-",
const char * openBranch = "[",
const char * closeBranch = "]",
const char * increasePtSize = ">",
const char * decreasePtSize = "<",
const char * XFactor = "X",
const char * YFactor = "Y",
const char * AFactor = "A",
const char * BFactor = "B",
const char * CFactor = "C",
const char * DFactor = "D",
const char * EFactor = "E",
const char * null = "",
int AxiomInPrompt = 0
)

{
const char * ret = "
"; 
const char * fvl = " full value -> ";

    return NGLRender(
	width,
	height,
	bytes,
	"
		const char * temp = axiom;
		const char * t2 = null;
		float oldAngle[65535]; float oldX[65535]; float oldY[65535];
		float oldOX[65535]; float oldOY[65535]; 
		float oldCV[65535]; float oldSV[65535];
		float oldSize[65535];
		float oldR[65535]; float oldG[65535]; float oldB[65535];
		    for(int n=iteration; n>0; n--)
		    {
			t2 = null;
			int lng = strlen(temp) +1;
			for(int p=0; p<lng; p++)
			{
				const char * c1 = strsub(temp , p, 1);
				if( c1 == factorDraw ) { t2 = t2 + F; } 
				else if(c1 == XFactor)
					{t2 = t2 + X;}
				else if(c1 == YFactor)
					{t2 = t2 + Y;}
				else if(c1 == AFactor)
					{t2 = t2 + A;}
				else if(c1 == BFactor)
					{t2 = t2 + B;}
				else if(c1 == CFactor)
					{t2 = t2 + C;}
				else if(c1 == DFactor)
					{t2 = t2 + D;}
				else if(c1 == EFactor)
					{t2 = t2 + E;}
				else {t2 = t2 + c1;}
				
			}
			temp = t2; 
		    }
		    if (AxiomInPrompt == 1) {printf(ret); printf(fvl); printf(temp);}
		    int L = strlen(temp)+1; 
		    int angle2 = startAngle;
		    float x = xCenter; float y = yCenter;
		    float ox = x; float oy = y; 
		    float cv = cosd(angle2) * zoom; 
		    float sv = sind(angle2) * zoom;
		    float col = 1.0; float fact = stepColor;
		    float r = Red; float g = Green; float b = Blue;
		    float moveSize = ptStepSize;
		    int cur = 1;

	for(int loop=0; loop< L; loop++)
	{
		const char * c2 = strsub(temp, loop, 1); 
		if (c2 == factorDraw) {ox = x; oy = y; x = x+cv; y =y+ sv;
			nglPointSize(ptBaseSize+moveSize);
			nglColor3f( r, g, b);
			if( drawType == \"Line\"  ) { nglBegin(NGL_LINES) ; nglVertex2f( x, y); nglVertex2f( ox, oy); nglEnd();}
			if( drawType == \"Point\" ) { nglBegin(NGL_POINTS); nglVertex2f( x, y); nglEnd();}
			}
		if (c2 == factorNoDraw) {ox = x; oy = y; x = x+   cv; y = y+   sv;}
		if (c2 == reverseAngle) {ox = x; oy = y; x = x-   cv; y = y-   sv;}
		if (c2 == increaseAngle)   {angle2 =angle2+ angle;
			cv = cosd(angle2) * zoom; 
			sv = sind(angle2) * zoom;}
		if (c2 == decreaseAngle) {angle2 =angle2 -  angle;
			cv = cosd(angle2) * zoom; 
			sv = sind(angle2) * zoom;}
		if (c2 == increaseColor) {
			r = r  + stepColor; if (r >=1) {r = 0}
			g = g  + stepColor; if (g >=1) {g = 0}
			b = b  + stepColor; if (b >=1) {b = 0}
		}
		if (c2 == decreaseColor) {
			r = r  - stepColor; if (r <=0) {r = 1}
			g = g  - stepColor; if (g <=0) {g = 1}
			b = b  - stepColor; if (b <=0) {b = 1}
		}
		if (c2 == openBranch) {
			oldAngle[cur] = angle2;
			oldX[cur] = x; oldY[cur] = y;
			oldOX[cur] = ox ; oldOY[cur] = oy;
			oldCV[cur] = cv ; oldSV[cur] = sv;
			oldSize[cur] = moveSize;
			oldR[cur] = r; oldG[cur] = g; oldB[cur] = b;
			cur +=1;
		}
		if (c2 == closeBranch) {
			cur -=1;
			angle2 = oldAngle[cur];
			x = oldX[cur] ; y = oldY[cur];
			ox = oldOX[cur]; oy = oldOY[cur];
			cv = oldCV[cur]; sv = oldSV[cur];
			moveSize = oldSize[cur];
			r = oldR[cur]; g = oldG[cur]; b = oldB[cur];
		}
		if (c2 == increasePtSize) {
			moveSize = moveSize + ptStepSize
		}
		if (c2 == decreasePtSize) {
			moveSize = moveSize - ptStepSize
		}
	}
	"
    );
}
